module NML
implicit none

contains
    
real function Zeroin(Fun, AX, BX, Eps)
! ZEROIN  :  . 
!"   " .  1980
interface
  real function Fun(x)
    real, intent(in):: x
  end function Fun
end interface
real, intent(in):: AX, BX, Eps
real ME2, A, B, C, Xm, FA, FB, FC
real D, E, Tol, P, Q, R, S
!begin
  ME2=epsilon(1.0)
    !  
  A=AX; B=BX
  FA=Fun(A); FB=Fun(B)
20 continue      ! 
  C=A; FC=FA
  D=B-A; E=D
30 continue
  if (abs(FC)<abs(FB)) then
    A=B; B=C; C=A
    FA=FB; FB=FC; FC=FA
  end if
40 continue      ! 
  if (abs(FB)==0.0) then; Zeroin=B; return; end if
  Tol=ME2*abs(B)+0.5*Eps
  Xm=0.5*(C-B)
  if (abs(Xm)<Tol) then; Zeroin=B; return; end if
    !  
  if (abs(E)<Tol.OR.abs(FA)<=abs(FB)) goto 70
    !   
  if (A==C) then
    S=FB/FA      ! 
    P=2.0*Xm*S
    Q=1.0-S
  else
    Q=FA/FC      ! 
    R=FB/FC      !
    S=FB/FA
    P=S*(2.0*Xm*Q*(Q-R)-(B-A)*(R-1.0))
    Q=(Q-1.0)*(R-1.0)*(S-1.0)
  end if
  if (P>0) then; Q=-Q    ! 
           else; P=abs(P)
  end if
    !  
  if (2.0*P>=3.0*Xm*Q-abs(Tol*Q)) goto 70
  if (P>=abs(0.5*E*Q)) goto 70
  E=D; D=P/Q
  goto 80
70 continue      !
  D=Xm; E=D
80 continue      ! 
  A=B; FA=FB
  if (abs(D)>Tol) then; B=B+D
                  else; B=B+sign(Tol, Xm)
  end if
  FB=Fun(B)
  if ((sign(1.0,FB)>0).EQV.(sign(1.0,FC)>0)) goto 20
  goto 30
end function Zeroin

end module NML
